package com.yice.webadmin.app.service.impl;

import cn.hutool.core.collection.CollUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.github.pagehelper.Page;
import com.yice.common.core.base.dao.BaseDaoMapper;
import com.yice.common.core.base.service.BaseService;
import com.yice.common.core.object.MyRelationParam;
import com.yice.common.core.util.MyModelUtil;
import com.yice.common.sequence.wrapper.IdGeneratorWrapper;
import com.yice.webadmin.app.dao.KnowledgeManageMapper;
import com.yice.webadmin.app.dao.KnowledgeUserMapper;
import com.yice.webadmin.app.model.KnowledgeManage;
import com.yice.webadmin.app.model.KnowledgeUser;
import com.yice.webadmin.app.service.KnowledgeManageService;
import com.yice.webadmin.upms.model.SysUser;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * 知识库管理数据操作服务类。
 *
 * @author linking
 * @date 2023-04-13
 */
@Slf4j
@Service("knowledgeManageService")
public class KnowledgeManageServiceImpl extends BaseService<KnowledgeManage, Long> implements KnowledgeManageService {

    @Autowired
    private KnowledgeManageMapper knowledgeManageMapper;
    @Autowired
    private IdGeneratorWrapper idGenerator;
    @Autowired
    private KnowledgeUserMapper knowledgeUserMapper;

    /**
     * 返回当前Service的主表Mapper对象。
     *
     * @return 主表Mapper对象。
     */
    @Override
    protected BaseDaoMapper<KnowledgeManage> mapper() {
        return knowledgeManageMapper;
    }

    /**
     * 保存新增对象。
     *
     * @param knowledgeManage 新增对象。
     * @return 返回新增对象。
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public KnowledgeManage saveNew(KnowledgeManage knowledgeManage) {
        knowledgeManageMapper.insert(this.buildDefaultValue(knowledgeManage));
        return knowledgeManage;
    }

    /**
     * 利用数据库的insertList语法，批量插入对象列表。
     *
     * @param knowledgeManageList 新增对象列表。
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public void saveNewBatch(List<KnowledgeManage> knowledgeManageList) {
        if (CollUtil.isNotEmpty(knowledgeManageList)) {
            knowledgeManageList.forEach(this::buildDefaultValue);
            knowledgeManageMapper.insertList(knowledgeManageList);
        }
    }

    /**
     * 批量新增用户页面关联。
     *
     * @param knowledgeUserList 用户页面关系数据列表。
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public void addKnowledgeUserList(List<KnowledgeUser> knowledgeUserList) {
        if(CollUtil.isNotEmpty(knowledgeUserList)){
            knowledgeUserMapper.insertList(knowledgeUserList);
        }
    }

    /**
     * 获取指定角色的用户列表。
     *
     * @param knowledgeId  知识库标识。
     * @param filter  用户过滤对象。
     * @param orderBy 排序参数。
     * @return 用户列表。
     */
    @Override
    public List<SysUser> getSysUserListByKnowledgeId(Long knowledgeId, SysUser filter, String orderBy) {
        return knowledgeUserMapper.getSysUserListByKnowledgeId(knowledgeId, filter, orderBy);
    }

    /**
     * 获取不属于指定知识库的用户列表。
     *
     * @param knowledgeId 知识库ID。
     * @param filter  用户过滤对象。
     * @param orderBy 排序参数。
     * @return 用户列表。
     */
    @Override
    public List<SysUser> getNotInSysUserListByKnowledgeId(Long knowledgeId, SysUser filter, String orderBy) {
        return knowledgeUserMapper.getNotInSysUserListByKnowledgeId(knowledgeId, filter, orderBy);
    }

    /**
     * 移除指定用户和指定知识库的关联关系。
     *
     * @param knowledgeId 知识库标识。
     * @param userId 用户主键Id。
     * @return 移除成功返回true，否则false。
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public boolean removeKnowledgeUser(Long knowledgeId, Long userId) {
        KnowledgeUser knowledgeUser  = new KnowledgeUser(userId, knowledgeId);
        return knowledgeUserMapper.delete(new QueryWrapper<>(knowledgeUser)) == 1;
    }

    /**
     * 更新数据对象。
     *
     * @param knowledgeManage         更新的对象。
     * @param originalKnowledgeManage 原有数据对象。
     * @return 成功返回true，否则false。
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public boolean update(KnowledgeManage knowledgeManage, KnowledgeManage originalKnowledgeManage) {
        MyModelUtil.fillCommonsForUpdate(knowledgeManage, originalKnowledgeManage);
        // 这里重点提示，在执行主表数据更新之前，如果有哪些字段不支持修改操作，请用原有数据对象字段替换当前数据字段。
        UpdateWrapper<KnowledgeManage> uw = this.createUpdateQueryForNullValue(knowledgeManage, knowledgeManage.getKnowledgeId());
        return knowledgeManageMapper.update(knowledgeManage, uw) == 1;
    }

    /**
     * 获取单表查询结果。由于没有关联数据查询，因此在仅仅获取单表数据的场景下，效率更高。
     *
     * @param filter  过滤对象。
     * @param orderBy 排序参数。
     * @return 查询结果集。
     */
    @Override
    public List<KnowledgeManage> loadKnowledgeUserList(KnowledgeManage filter, String orderBy) {
        if (filter == null) {
            filter = new KnowledgeManage();
        }
        return knowledgeManageMapper.loadKnowLedgeList(filter, orderBy);
    }

    /**
     * 删除指定数据。
     *
     * @param knowledgeId 主键Id。
     * @return 成功返回true，否则false。
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public boolean remove(Long knowledgeId) {
        return knowledgeManageMapper.deleteById(knowledgeId) == 1;
    }

    /**
     * 获取单表查询结果。由于没有关联数据查询，因此在仅仅获取单表数据的场景下，效率更高。
     * 如果需要同时获取关联数据，请移步(getKnowledgeManageListWithRelation)方法。
     *
     * @param filter  过滤对象。
     * @param orderBy 排序参数。
     * @return 查询结果集。
     */
    @Override
    public List<KnowledgeManage> getKnowledgeManageList(KnowledgeManage filter, String orderBy) {
        return knowledgeManageMapper.getKnowledgeManageList(filter, orderBy);
    }

    /**
     * 获取主表的查询结果，以及主表关联的字典数据和一对一从表数据，以及一对一从表的字典数据。
     * 该查询会涉及到一对一从表的关联过滤，或一对多从表的嵌套关联过滤，因此性能不如单表过滤。
     * 如果仅仅需要获取主表数据，请移步(getKnowledgeManageList)，以便获取更好的查询性能。
     *
     * @param filter  主表过滤对象。
     * @param orderBy 排序参数。
     * @return 查询结果集。
     */
    @Override
    public List<KnowledgeManage> getKnowledgeManageListWithRelation(KnowledgeManage filter, String orderBy) {
        List<KnowledgeManage> resultList = knowledgeManageMapper.getKnowledgeManageList(filter, orderBy);
        // 在缺省生成的代码中，如果查询结果resultList不是Page对象，说明没有分页，那么就很可能是数据导出接口调用了当前方法。
        // 为了避免一次性的大量数据关联，规避因此而造成的系统运行性能冲击，这里手动进行了分批次读取，开发者可按需修改该值。
        int batchSize = resultList instanceof Page ? 0 : 1000;
        this.buildRelationForDataList(resultList, MyRelationParam.normal(), batchSize);
        return resultList;
    }

    private KnowledgeManage buildDefaultValue(KnowledgeManage knowledgeManage) {
        if (knowledgeManage.getKnowledgeId() == null) {
            knowledgeManage.setKnowledgeId(idGenerator.nextLongId());
        }
        MyModelUtil.fillCommonsForInsert(knowledgeManage);
        return knowledgeManage;
    }
}
